bisect--helper: `check_and_set_terms` shell function in C
[git/git.git] / git-bisect.sh
CommitLineData
8cc6a083 1#!/bin/sh
d025524d 2
dbc349bb 3USAGE='[help|start|bad|good|new|old|terms|skip|next|reset|visualize|view|replay|log|run]'
243a60fb 4LONG_USAGE='git bisect help
6021be86 5 print this long help message.
06e6a745
MM
6git bisect start [--term-{old,good}=<term> --term-{new,bad}=<term>]
7 [--no-checkout] [<bad> [<good>...]] [--] [<pathspec>...]
6021be86 8 reset bisect state and start bisection.
21e5cfd8
AD
9git bisect (bad|new) [<rev>]
10 mark <rev> a known-bad revision/
11 a revision after change in a given property.
12git bisect (good|old) [<rev>...]
13 mark <rev>... known-good revisions/
14 revisions before change in a given property.
21b55e33
MM
15git bisect terms [--term-good | --term-bad]
16 show the terms used for old and new commits (default: bad, good)
5413812f 17git bisect skip [(<rev>|<range>)...]
6021be86 18 mark <rev>... untestable revisions.
38a47fd6 19git bisect next
6021be86 20 find next bisection to test and check it out.
6b87ce23 21git bisect reset [<commit>]
6021be86 22 finish bisection search and go back to commit.
dbc349bb 23git bisect (visualize|view)
6021be86 24 show bisect status in gitk.
38a47fd6 25git bisect replay <logfile>
6021be86 26 replay bisection log.
38a47fd6 27git bisect log
6021be86 28 show bisect log.
38a47fd6 29git bisect run <cmd>...
6021be86 30 use <cmd>... to automatically bisect.
243a60fb
CC
31
32Please use "git help bisect" to get the full man page.'
d025524d 33
8f321a39 34OPTIONS_SPEC=
ae2b0f15 35. git-sh-setup
8cc6a083 36
ce32660e
JS
37_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
38_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
43f9d9f3
AD
39TERM_BAD=bad
40TERM_GOOD=good
ce32660e 41
4796e823
JS
42bisect_head()
43{
44 if test -f "$GIT_DIR/BISECT_HEAD"
45 then
46 echo BISECT_HEAD
47 else
48 echo HEAD
49 fi
50}
51
8cc6a083 52bisect_autostart() {
823ea121 53 test -s "$GIT_DIR/BISECT_START" || {
3145b1a2 54 gettextln "You need to start by \"git bisect start\"" >&2
8cc6a083
LT
55 if test -t 0
56 then
04de0996
ÆAB
57 # TRANSLATORS: Make sure to include [Y] and [n] in your
58 # translation. The program will only accept English input
59 # at this point.
6021be86 60 gettext "Do you want me to do it for you [Y/n]? " >&2
8cc6a083
LT
61 read yesno
62 case "$yesno" in
63 [Nn]*)
64 exit ;;
65 esac
66 bisect_start
67 else
68 exit 1
69 fi
70 }
71}
72
73bisect_start() {
4764f464
JS
74 #
75 # Check for one bad and then some good revisions.
76 #
77 has_double_dash=0
78 for arg; do
6021be86 79 case "$arg" in --) has_double_dash=1; break ;; esac
4764f464
JS
80 done
81 orig_args=$(git rev-parse --sq-quote "$@")
82 bad_seen=0
83 eval=''
cb46d630 84 must_write_terms=0
4a6ada32 85 revs=''
24c51280
JS
86 if test "z$(git rev-parse --is-bare-repository)" != zfalse
87 then
88 mode=--no-checkout
89 else
90 mode=''
91 fi
4764f464 92 while [ $# -gt 0 ]; do
6021be86
JS
93 arg="$1"
94 case "$arg" in
95 --)
96 shift
97 break
4764f464 98 ;;
6021be86
JS
99 --no-checkout)
100 mode=--no-checkout
101 shift ;;
06e6a745
MM
102 --term-good|--term-old)
103 shift
104 must_write_terms=1
105 TERM_GOOD=$1
106 shift ;;
107 --term-good=*|--term-old=*)
108 must_write_terms=1
109 TERM_GOOD=${1#*=}
110 shift ;;
111 --term-bad|--term-new)
112 shift
113 must_write_terms=1
114 TERM_BAD=$1
115 shift ;;
116 --term-bad=*|--term-new=*)
117 must_write_terms=1
118 TERM_BAD=${1#*=}
119 shift ;;
6021be86
JS
120 --*)
121 die "$(eval_gettext "unrecognised option: '\$arg'")" ;;
122 *)
123 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
43b8ff4b
JH
124 test $has_double_dash -eq 1 &&
125 die "$(eval_gettext "'\$arg' does not appear to be a valid revision")"
126 break
6021be86 127 }
4a6ada32 128 revs="$revs $rev"
6021be86
JS
129 shift
130 ;;
4764f464 131 esac
4764f464
JS
132 done
133
4a6ada32
MM
134 for rev in $revs
135 do
136 # The user ran "git bisect start <sha1>
137 # <sha1>", hence did not explicitly specify
138 # the terms, but we are already starting to
139 # set references named with the default terms,
140 # and won't be able to change afterwards.
141 must_write_terms=1
142
143 case $bad_seen in
144 0) state=$TERM_BAD ; bad_seen=1 ;;
145 *) state=$TERM_GOOD ;;
146 esac
0f30233a 147 eval="$eval git bisect--helper --bisect-write '$state' '$rev' '$TERM_GOOD' '$TERM_BAD' 'nolog' &&"
4a6ada32 148 done
8cc6a083 149 #
634f2464 150 # Verify HEAD.
8cc6a083 151 #
48949a18 152 head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
ce32660e 153 head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
9570fc1e 154 die "$(gettext "Bad HEAD - I need a HEAD")"
634f2464 155
ee831f7d 156 #
634f2464 157 # Check if we are bisecting.
ee831f7d 158 #
d3e54c88 159 start_head=''
634f2464
CC
160 if test -s "$GIT_DIR/BISECT_START"
161 then
162 # Reset to the rev from where we started.
9d0cd91c 163 start_head=$(cat "$GIT_DIR/BISECT_START")
4796e823
JS
164 if test "z$mode" != "z--no-checkout"
165 then
1acf1171 166 git checkout "$start_head" -- ||
9c9b4f2f 167 die "$(eval_gettext "Checking out '\$start_head' failed. Try 'git bisect reset <valid-branch>'.")"
4796e823 168 fi
634f2464
CC
169 else
170 # Get rev from where we start.
171 case "$head" in
172 refs/heads/*|$_x40)
173 # This error message should only be triggered by
174 # cogito usage, and cogito users should understand
175 # it relates to cg-seek.
176 [ -s "$GIT_DIR/head-name" ] &&
382d20e3 177 die "$(gettext "won't bisect on cg-seek'ed tree")"
634f2464
CC
178 start_head="${head#refs/heads/}"
179 ;;
180 *)
9570fc1e 181 die "$(gettext "Bad HEAD - strange symbolic ref")"
634f2464
CC
182 ;;
183 esac
184 fi
8cc6a083
LT
185
186 #
634f2464 187 # Get rid of any old bisect state.
8cc6a083 188 #
fb71a329 189 git bisect--helper --bisect-clean-state || exit
38a47fd6 190
ba963de8
CC
191 #
192 # Change state.
193 # In case of mistaken revs or checkout error, or signals received,
194 # "bisect_auto_next" below may exit or misbehave.
195 # We have to trap this to be able to clean up using
196 # "bisect_clean_state".
197 #
fb71a329 198 trap 'git bisect--helper --bisect-clean-state' 0
ba963de8
CC
199 trap 'exit 255' 1 2 3 15
200
201 #
202 # Write new start state.
203 #
4796e823
JS
204 echo "$start_head" >"$GIT_DIR/BISECT_START" && {
205 test "z$mode" != "z--no-checkout" ||
206 git update-ref --no-deref BISECT_HEAD "$start_head"
207 } &&
de52f5a8 208 git rev-parse --sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
6ba7acff 209 eval "$eval true" &&
cb46d630
AD
210 if test $must_write_terms -eq 1
211 then
ecb3f373 212 git bisect--helper --write-terms "$TERM_BAD" "$TERM_GOOD" || exit
cb46d630 213 fi &&
6c98c054 214 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
ba963de8
CC
215 #
216 # Check if we can proceed to the next bisect state.
217 #
38a47fd6 218 bisect_auto_next
ba963de8
CC
219
220 trap '-' 0
8cc6a083
LT
221}
222
ee2314f5 223bisect_skip() {
6021be86 224 all=''
ee2314f5
CC
225 for arg in "$@"
226 do
6021be86
JS
227 case "$arg" in
228 *..*)
229 revs=$(git rev-list "$arg") || die "$(eval_gettext "Bad rev input: \$arg")" ;;
230 *)
231 revs=$(git rev-parse --sq-quote "$arg") ;;
232 esac
233 all="$all $revs"
234 done
235 eval bisect_state 'skip' $all
ee2314f5
CC
236}
237
155fc795 238bisect_state() {
8cc6a083 239 bisect_autostart
155fc795 240 state=$1
4fbdbd5b
PB
241 git bisect--helper --check-and-set-terms $state $TERM_GOOD $TERM_BAD || exit
242 get_terms
155fc795
CC
243 case "$#,$state" in
244 0,*)
f813fb41 245 die "Please call 'bisect_state' with at least one argument." ;;
43f9d9f3 246 1,"$TERM_BAD"|1,"$TERM_GOOD"|1,skip)
57984dd9
VA
247 bisected_head=$(bisect_head)
248 rev=$(git rev-parse --verify "$bisected_head") ||
249 die "$(eval_gettext "Bad rev input: \$bisected_head")"
0f30233a 250 git bisect--helper --bisect-write "$state" "$rev" "$TERM_GOOD" "$TERM_BAD" || exit
b903674b 251 git bisect--helper --check-expected-revs "$rev" ;;
43f9d9f3 252 2,"$TERM_BAD"|*,"$TERM_GOOD"|*,skip)
155fc795 253 shift
6bc02d56 254 hash_list=''
e3389075 255 for rev in "$@"
155fc795 256 do
a179a303 257 sha=$(git rev-parse --verify "$rev^{commit}") ||
15eaa049 258 die "$(eval_gettext "Bad rev input: \$rev")"
6bc02d56 259 hash_list="$hash_list $sha"
d3e54c88 260 done
6bc02d56
CC
261 for rev in $hash_list
262 do
0f30233a 263 git bisect--helper --bisect-write "$state" "$rev" "$TERM_GOOD" "$TERM_BAD" || exit
6bc02d56 264 done
b903674b 265 git bisect--helper --check-expected-revs $hash_list ;;
43f9d9f3
AD
266 *,"$TERM_BAD")
267 die "$(eval_gettext "'git bisect \$TERM_BAD' can take only one argument.")" ;;
cc9f24d0
JH
268 *)
269 usage ;;
8cc6a083 270 esac
97e1c51e
CC
271 bisect_auto_next
272}
273
8cc6a083 274bisect_next_check() {
0a5280a9 275 missing_good= missing_bad=
43f9d9f3
AD
276 git show-ref -q --verify refs/bisect/$TERM_BAD || missing_bad=t
277 test -n "$(git for-each-ref "refs/bisect/$TERM_GOOD-*")" || missing_good=t
6fecf191 278
0a5280a9
JH
279 case "$missing_good,$missing_bad,$1" in
280 ,,*)
43f9d9f3 281 : have both $TERM_GOOD and $TERM_BAD - ok
0a5280a9
JH
282 ;;
283 *,)
284 # do not have both but not asked to fail - just report.
285 false
286 ;;
43f9d9f3 287 t,,"$TERM_GOOD")
21e5cfd8 288 # have bad (or new) but not good (or old). we could bisect although
0a5280a9 289 # this is less optimum.
43f9d9f3 290 eval_gettextln "Warning: bisecting only with a \$TERM_BAD commit." >&2
0a5280a9
JH
291 if test -t 0
292 then
04de0996
ÆAB
293 # TRANSLATORS: Make sure to include [Y] and [n] in your
294 # translation. The program will only accept English input
295 # at this point.
296 gettext "Are you sure [Y/n]? " >&2
e5d3afd7
FM
297 read yesno
298 case "$yesno" in [Nn]*) exit 1 ;; esac
0a5280a9 299 fi
43f9d9f3 300 : bisect without $TERM_GOOD...
0a5280a9 301 ;;
8cc6a083 302 *)
cb46d630
AD
303 bad_syn=$(bisect_voc bad)
304 good_syn=$(bisect_voc good)
be508d3a
ÆAB
305 if test -s "$GIT_DIR/BISECT_START"
306 then
cb46d630
AD
307
308 eval_gettextln "You need to give me at least one \$bad_syn and one \$good_syn revision.
309(You can use \"git bisect \$bad_syn\" and \"git bisect \$good_syn\" for that.)" >&2
be508d3a 310 else
cb46d630
AD
311 eval_gettextln "You need to start by \"git bisect start\".
312You then need to give me at least one \$good_syn and one \$bad_syn revision.
313(You can use \"git bisect \$bad_syn\" and \"git bisect \$good_syn\" for that.)" >&2
be508d3a 314 fi
0a5280a9 315 exit 1 ;;
8cc6a083
LT
316 esac
317}
318
319bisect_auto_next() {
434d036f 320 bisect_next_check && bisect_next || :
8cc6a083
LT
321}
322
323bisect_next() {
8fe26f44 324 case "$#" in 0) ;; *) usage ;; esac
8cc6a083 325 bisect_autostart
43f9d9f3 326 bisect_next_check $TERM_GOOD
0a5280a9 327
0871984d 328 # Perform all bisection computation, display and checkout
4796e823 329 git bisect--helper --next-all $(test -f "$GIT_DIR/BISECT_HEAD" && echo --no-checkout)
5a1d31c7 330 res=$?
0a5280a9 331
6021be86 332 # Check if we should exit because bisection is finished
a7f8b8ac
TH
333 if test $res -eq 10
334 then
43f9d9f3 335 bad_rev=$(git show-ref --hash --verify refs/bisect/$TERM_BAD)
a7f8b8ac 336 bad_commit=$(git show-branch $bad_rev)
43f9d9f3 337 echo "# first $TERM_BAD commit: $bad_commit" >>"$GIT_DIR/BISECT_LOG"
a7f8b8ac 338 exit 0
f989cac9
TH
339 elif test $res -eq 2
340 then
341 echo "# only skipped commits left to test" >>"$GIT_DIR/BISECT_LOG"
43f9d9f3
AD
342 good_revs=$(git for-each-ref --format="%(objectname)" "refs/bisect/$TERM_GOOD-*")
343 for skipped in $(git rev-list refs/bisect/$TERM_BAD --not $good_revs)
f989cac9
TH
344 do
345 skipped_commit=$(git show-branch $skipped)
43f9d9f3 346 echo "# possible first $TERM_BAD commit: $skipped_commit" >>"$GIT_DIR/BISECT_LOG"
f989cac9
TH
347 done
348 exit $res
a7f8b8ac 349 fi
0a5280a9 350
5a1d31c7
CC
351 # Check for an error in the bisection process
352 test $res -ne 0 && exit $res
353
354 return 0
8cc6a083
LT
355}
356
cc9f24d0
JH
357bisect_visualize() {
358 bisect_next_check fail
235997c9
JH
359
360 if test $# = 0
361 then
c4e4644e 362 if test -n "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" &&
43b8ff4b 363 type gitk >/dev/null 2>&1
eef12a9a 364 then
c4e4644e
JK
365 set gitk
366 else
367 set git log
368 fi
235997c9
JH
369 else
370 case "$1" in
371 git*|tig) ;;
372 -*) set git log "$@" ;;
373 *) set git "$@" ;;
374 esac
375 fi
376
fc13aa3d 377 eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
cc9f24d0
JH
378}
379
e204de28 380bisect_replay () {
55a9fc80
ÆAB
381 file="$1"
382 test "$#" -eq 1 || die "$(gettext "No logfile given")"
383 test -r "$file" || die "$(eval_gettext "cannot read \$file for replaying")"
5e82c3dd 384 git bisect--helper --bisect-reset || exit
6c98c054 385 while read git bisect command rev
e204de28 386 do
c82af12a 387 test "$git $bisect" = "git bisect" || test "$git" = "git-bisect" || continue
eef12a9a
JS
388 if test "$git" = "git-bisect"
389 then
6c98c054
MV
390 rev="$command"
391 command="$bisect"
392 fi
cb46d630 393 get_terms
4fbdbd5b
PB
394 git bisect--helper --check-and-set-terms "$command" "$TERM_GOOD" "$TERM_BAD" || exit
395 get_terms
e204de28
JH
396 case "$command" in
397 start)
e9a45d75 398 cmd="bisect_start $rev"
737c74ee 399 eval "$cmd" ;;
cb46d630 400 "$TERM_GOOD"|"$TERM_BAD"|skip)
0f30233a 401 git bisect--helper --bisect-write "$command" "$rev" "$TERM_GOOD" "$TERM_BAD" || exit;;
21b55e33
MM
402 terms)
403 bisect_terms $rev ;;
e204de28 404 *)
9570fc1e 405 die "$(gettext "?? what are you talking about?")" ;;
e204de28 406 esac
55a9fc80 407 done <"$file"
e204de28 408 bisect_auto_next
8cc6a083
LT
409}
410
a17c4101 411bisect_run () {
6021be86
JS
412 bisect_next_check fail
413
fecd2dd3
SB
414 test -n "$*" || die "$(gettext "bisect run failed: no command provided.")"
415
6021be86
JS
416 while true
417 do
418 command="$@"
3145b1a2 419 eval_gettextln "running \$command"
6021be86
JS
420 "$@"
421 res=$?
422
423 # Check for really bad run error.
eef12a9a
JS
424 if [ $res -lt 0 -o $res -ge 128 ]
425 then
3145b1a2
JS
426 eval_gettextln "bisect run failed:
427exit code \$res from '\$command' is < 0 or >= 128" >&2
6021be86
JS
428 exit $res
429 fi
430
431 # Find current state depending on run success or failure.
432 # A special exit code of 125 means cannot test.
eef12a9a
JS
433 if [ $res -eq 125 ]
434 then
6021be86 435 state='skip'
eef12a9a
JS
436 elif [ $res -gt 0 ]
437 then
43f9d9f3 438 state="$TERM_BAD"
6021be86 439 else
43f9d9f3 440 state="$TERM_GOOD"
6021be86
JS
441 fi
442
443 # We have to use a subshell because "bisect_state" can exit.
305a233c 444 ( bisect_state $state >"$GIT_DIR/BISECT_RUN" )
6021be86
JS
445 res=$?
446
447 cat "$GIT_DIR/BISECT_RUN"
448
43f9d9f3 449 if sane_grep "first $TERM_BAD commit could be any of" "$GIT_DIR/BISECT_RUN" \
305a233c 450 >/dev/null
eef12a9a 451 then
3145b1a2 452 gettextln "bisect run cannot continue any more" >&2
6021be86
JS
453 exit $res
454 fi
455
eef12a9a
JS
456 if [ $res -ne 0 ]
457 then
3145b1a2
JS
458 eval_gettextln "bisect run failed:
459'bisect_state \$state' exited with error code \$res" >&2
6021be86
JS
460 exit $res
461 fi
a17c4101 462
43f9d9f3 463 if sane_grep "is the first $TERM_BAD commit" "$GIT_DIR/BISECT_RUN" >/dev/null
eef12a9a 464 then
3145b1a2 465 gettextln "bisect run success"
6021be86
JS
466 exit 0;
467 fi
a17c4101 468
6021be86 469 done
a17c4101
CC
470}
471
412ff738 472bisect_log () {
9570fc1e 473 test -s "$GIT_DIR/BISECT_LOG" || die "$(gettext "We are not bisecting.")"
412ff738
SG
474 cat "$GIT_DIR/BISECT_LOG"
475}
a17c4101 476
cb46d630
AD
477get_terms () {
478 if test -s "$GIT_DIR/BISECT_TERMS"
479 then
480 {
481 read TERM_BAD
482 read TERM_GOOD
483 } <"$GIT_DIR/BISECT_TERMS"
484 fi
485}
486
cb46d630
AD
487bisect_voc () {
488 case "$1" in
21e5cfd8
AD
489 bad) echo "bad|new" ;;
490 good) echo "good|old" ;;
cb46d630
AD
491 esac
492}
493
21b55e33
MM
494bisect_terms () {
495 get_terms
496 if ! test -s "$GIT_DIR/BISECT_TERMS"
497 then
498 die "$(gettext "no terms defined")"
499 fi
500 case "$#" in
501 0)
502 gettextln "Your current terms are $TERM_GOOD for the old state
503and $TERM_BAD for the new state."
504 ;;
505 1)
506 arg=$1
507 case "$arg" in
508 --term-good|--term-old)
509 printf '%s\n' "$TERM_GOOD"
510 ;;
511 --term-bad|--term-new)
512 printf '%s\n' "$TERM_BAD"
513 ;;
514 *)
515 die "$(eval_gettext "invalid argument \$arg for 'git bisect terms'.
516Supported options are: --term-good|--term-old and --term-bad|--term-new.")"
517 ;;
518 esac
519 ;;
520 *)
521 usage ;;
522 esac
523}
524
8cc6a083
LT
525case "$#" in
5260)
6021be86 527 usage ;;
8cc6a083 528*)
6021be86 529 cmd="$1"
cb46d630 530 get_terms
6021be86
JS
531 shift
532 case "$cmd" in
533 help)
534 git bisect -h ;;
535 start)
536 bisect_start "$@" ;;
21e5cfd8 537 bad|good|new|old|"$TERM_BAD"|"$TERM_GOOD")
6021be86
JS
538 bisect_state "$cmd" "$@" ;;
539 skip)
540 bisect_skip "$@" ;;
541 next)
542 # Not sure we want "next" at the UI level anymore.
543 bisect_next "$@" ;;
544 visualize|view)
545 bisect_visualize "$@" ;;
546 reset)
5e82c3dd 547 git bisect--helper --bisect-reset "$@" ;;
6021be86
JS
548 replay)
549 bisect_replay "$@" ;;
550 log)
551 bisect_log ;;
552 run)
553 bisect_run "$@" ;;
21b55e33
MM
554 terms)
555 bisect_terms "$@" ;;
6021be86
JS
556 *)
557 usage ;;
558 esac
8cc6a083 559esac